## openscad 2011.12

=== tests/CMakeLists.txt ===
# instructions - see ../doc/testing.txt

cmake_minimum_required(VERSION 2.8)
if("${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION}" VERSION_GREATER 2.8.3)
  # Explicitly use new include policy to avoid globally shadowing included modules
  # http://www.cmake.org/cmake/help/cmake-2-8-docs.html#policy:CMP0017
  cmake_policy(SET CMP0017 NEW)
endif()
project(tests)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")

# Build debug build as default
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing")
endif()

if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDEBUG")
endif()

#
# Windows
#

if(WIN32)
  set(WIN32_STATIC_BUILD "True")
endif()

if(WIN32_STATIC_BUILD)
  if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    set(EMSG "\nTo build Win32 STATIC OpenSCAD please see doc/testing.txt")
    message(FATAL_ERROR ${EMSG})
  endif()
endif()

# Disable warnings
if(WIN32)
  # too long decorated names
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4503")
  # int cast to bool in CGAL
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4800")
  # unreferenced parameters in CGAL
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4100")
  # fopen_s advertisement
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_CRT_SECURE_NO_DEPRECATE")
  # lexer uses strdup & other POSIX stuff
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_CRT_NONSTDC_NO_DEPRECATE")
  # M_PI
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_USE_MATH_DEFINES")
endif()

# Debugging - if you uncomment, use nmake -f Makefile > log.txt (the log is big)
if(WIN32)
  # Linker debugging
  #set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -VERBOSE")

  # Compiler debugging
  # you have to pass -DCMAKE_VERBOSE_MAKEFILE=ON to cmake when you run it. 
endif()

#
# Build test apps
#

function(inclusion user_set_path found_paths)
  # This function exists as a wrapper for INCLUDE_DIRECTORIES
  # to deal with systems in which some libraries are found 
  # in the system paths, (/usr) but others are found in customized 
  # paths set in environment variables (CGAL_DIR). 
  # message(STATUS "inclusion ${user_set_path} ${found_paths}")
  # message(STATUS "inclusion ${${user_set_path}} ${${found_paths}}")
  set( inclusion_match 0 )
  foreach( found_path ${${found_paths}} )
    if (${found_path} MATCHES ${${user_set_path}}.*)
      set( inclusion_match 1 )
    endif()
  endforeach()
  if (user_set_path AND inclusion_match)
    include_directories(BEFORE ${${found_paths}})
    # message(STATUS "inclusion prepend ${${found_paths}} for ${user_set_path}")
  else()
    include_directories(AFTER ${${found_paths}})
    # message(STATUS "inclusion append ${${found_paths}} for ${user_set_path}")
  endif()
  set( inclusion_match 0 )
endfunction()

# Boost
# Update this if FindBoost.cmake gets out of sync with the current boost release
# set(Boost_ADDITIONAL_VERSIONS "1.47.0" "1.46.0")

if (WIN32)
  set(Boost_USE_STATIC_LIBS TRUE)
  set(BOOST_STATIC TRUE)
  set(BOOST_THREAD_USE_LIB TRUE)
endif()

if (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(BOOST_ROOT "$ENV{OPENSCAD_LIBRARIES}")
  if (EXISTS ${BOOST_ROOT}/include/boost)
    # if boost is under OPENSCAD_LIBRARIES, then 
    # don't look in the system paths (workaround FindBoost.cmake bug)
    set(Boost_NO_SYSTEM_PATHS "TRUE")
    message(STATUS "BOOST_ROOT: " ${BOOST_ROOT})
  endif()
endif()

if (NOT $ENV{BOOSTDIR} STREQUAL "")
  set(BOOST_ROOT "$ENV{BOOSTDIR}")
  set(Boost_NO_SYSTEM_PATHS "TRUE")
  set(Boost_DEBUG TRUE)
  message(STATUS "BOOST_ROOT: " ${BOOST_ROOT})
endif()

find_package( Boost 1.35.0 COMPONENTS thread program_options REQUIRED)
message(STATUS "Boost includes found: " ${Boost_INCLUDE_DIRS})
message(STATUS "Boost libraries found:")
foreach(boostlib ${Boost_LIBRARIES})
  message(STATUS "  " ${boostlib})
endforeach()

inclusion(BOOST_ROOT Boost_INCLUDE_DIRS)

# Mac OS X
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  FIND_LIBRARY(COCOA_LIBRARY Cocoa REQUIRED)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

# Qt4

set(CMAKE_INCLUDE_DIRECTORIES_BEFORE ON)
find_package(OpenGL REQUIRED)
find_package(Qt4 COMPONENTS QtCore QtGui QtOpenGL REQUIRED)
include(${QT_USE_FILE})
set(CMAKE_INCLUDE_DIRECTORIES_BEFORE OFF)

# Eigen2

# Turn off Eigen SIMD optimization
if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DEIGEN_DONT_ALIGN")
  endif()
endif()

if (NOT $ENV{EIGEN2DIR} STREQUAL "")
  set(EIGEN2_DIR "$ENV{EIGEN2DIR}")
elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(EIGEN2_DIR "$ENV{OPENSCAD_LIBRARIES}")
endif()

if (NOT EIGEN2_INCLUDE_DIR)
  if (EIGEN2_DIR)
    set(EIGEN2_FIND_HINTS "${EIGEN2_DIR}/include/eigen2")
  endif()
  if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    set(EIGEN2_FIND_PATHS /usr/local/include/eigen2)
  else()
    set(EIGEN2_FIND_PATHS /opt/local/include/eigen2 /usr/include/eigen2)
  endif()
  find_path(EIGEN2_INCLUDE_DIR
            Eigen/Core 
            HINTS ${EIGEN2_FIND_HINTS}
            PATHS ${EIGEN2_FIND_PATHS})
  if (NOT EIGEN2_INCLUDE_DIR)
    message(FATAL_ERROR "Eigen2 not found")
  else()
    message(STATUS "Eigen2 found in " ${EIGEN2_INCLUDE_DIR})
  endif()
endif()
inclusion(EIGEN2_DIR EIGEN2_INCLUDE_DIR)

# OpenCSG
if (NOT $ENV{OPENCSGDIR} STREQUAL "")
  set(OPENCSG_DIR "$ENV{OPENCSGDIR}")
elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(OPENCSG_DIR "$ENV{OPENSCAD_LIBRARIES}")
endif()
if (NOT OPENCSG_INCLUDE_DIR)
  message(STATUS "OPENCSG_DIR: " ${OPENCSG_DIR})
  find_path(OPENCSG_INCLUDE_DIR
            opencsg.h
            HINTS ${OPENCSG_DIR}/include)
  find_library(OPENCSG_LIBRARY
               opencsg
               HINTS ${OPENCSG_DIR}/lib)
  if (NOT OPENCSG_INCLUDE_DIR OR NOT OPENCSG_LIBRARY)
    message(FATAL_ERROR "OpenCSG not found")
  else()
    message(STATUS "OpenCSG include found in " ${OPENCSG_INCLUDE_DIR})
    message(STATUS "OpenCSG library found in " ${OPENCSG_LIBRARY})
  endif()
endif()
inclusion(OPENCSG_DIR OPENCSG_INCLUDE_DIR)

# GLEW

if(WIN32_STATIC_BUILD)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DGLEW_STATIC")
endif()

if (NOT $ENV{GLEWDIR} STREQUAL "")
  set(GLEW_DIR "$ENV{GLEWDIR}")
elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(GLEW_DIR "$ENV{OPENSCAD_LIBRARIES}")
endif()

find_package(GLEW REQUIRED)

inclusion( GLEW_DIR GLEW_INCLUDE_PATH )

# Flex/Bison
find_package(BISON REQUIRED)

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  # FreeBSD has an old flex in /usr/bin and a new flex in /usr/local/bin
  set(FLEX_EXECUTABLE /usr/local/bin/flex)
endif()

find_package(FLEX REQUIRED)
# The COMPILE_FLAGS and forced C++ compiler is just to be compatible with qmake
if (WIN32)
  set(FLEX_UNISTD_FLAG "-DYY_NO_UNISTD_H")
endif()
FLEX_TARGET(OpenSCADlexer ../src/lexer.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.cpp COMPILE_FLAGS "-Plexer ${FLEX_UNISTD_FLAG}")
BISON_TARGET(OpenSCADparser ../src/parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser_yacc.c COMPILE_FLAGS "-p parser")
ADD_FLEX_BISON_DEPENDENCY(OpenSCADlexer OpenSCADparser)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/parser_yacc.c PROPERTIES LANGUAGE "CXX")

# CGAL

if (NOT $ENV{CGALDIR} STREQUAL "")
  set(CGAL_DIR "$ENV{CGALDIR}")
elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  if (EXISTS "$ENV{OPENSCAD_LIBRARIES}/lib/CGAL")
    set(CGAL_DIR "$ENV{OPENSCAD_LIBRARIES}/lib/CGAL")
    set(CMAKE_MODULE_PATH "${CGAL_DIR}")
  elseif (EXISTS "$ENV{OPENSCAD_LIBRARIES}/include/CGAL")
    set(CGAL_DIR "$ENV{OPENSCAD_LIBRARIES}")
    set(CMAKE_MODULE_PATH "${CGAL_DIR}")
  endif()
endif()
message(STATUS "CGAL_DIR: " ${CGAL_DIR})
find_package(CGAL REQUIRED)
message(STATUS "CGAL config found in " ${CGAL_USE_FILE} )
foreach(cgal_incdir ${CGAL_INCLUDE_DIRS})
  message(STATUS "CGAL include found in " ${cgal_incdir} )
endforeach()
message(STATUS "CGAL libraries found in " ${CGAL_LIBRARIES_DIR} )
if("${CGAL_MAJOR_VERSION}.${CGAL_MINOR_VERSION}" VERSION_LESS 3.6)
  message(FATAL_ERROR "CGAL >= 3.6 required")
endif()
inclusion(CGAL_DIR CGAL_INCLUDE_DIRS)

# Imagemagick

find_package(ImageMagick COMPONENTS convert)
if (ImageMagick_convert_FOUND)
  message(STATUS "ImageMagick convert executable found: " ${ImageMagick_convert_EXECUTABLE})
else()
  message(FATAL_ERROR "Couldn't find imagemagick 'convert' program")
endif()

# Internal includes
include_directories(../src)

add_definitions(-DOPENSCAD_VERSION=test -DOPENSCAD_YEAR=2011 -DOPENSCAD_MONTH=10)
add_definitions(-DOPENSCAD_TESTING)

set(CORE_SOURCES
  tests-common.cc 
  ../src/mathc99.cc
  ../src/linalg.cc
  ../src/handle_dep.cc 
  ../src/value.cc 
  ../src/expr.cc 
  ../src/func.cc 
  ../src/module.cc 
  ../src/node.cc 
  ../src/context.cc 
  ../src/csgterm.cc 
  ../src/csgtermnormalizer.cc 
  ../src/polyset.cc 
  ../src/csgops.cc 
  ../src/transform.cc 
  ../src/color.cc 
  ../src/primitives.cc 
  ../src/projection.cc 
  ../src/cgaladv.cc 
  ../src/surface.cc 
  ../src/control.cc 
  ../src/render.cc 
  ../src/dxfdata.cc 
  ../src/dxfdim.cc 
  ../src/linearextrude.cc 
  ../src/rotateextrude.cc 
  ../src/printutils.cc 
  ../src/progress.cc 
  ${FLEX_OpenSCADlexer_OUTPUTS}
  ${BISON_OpenSCADparser_OUTPUTS})

set(NOCGAL_SOURCES
  ../src/builtin.cc 
  ../src/dxftess.cc 
  ../src/import.cc
  ../src/export.cc) 

set(CGAL_SOURCES
  ${NOCGAL_SOURCES}
	  ../src/CSGTermEvaluator.cc 
  ../src/CGAL_Nef_polyhedron.cc 
  ../src/cgalutils.cc 
  ../src/CGALEvaluator.cc
  ../src/CGALCache.cc
  ../src/PolySetCGALEvaluator.cc
  ../src/CGAL_Nef_polyhedron_DxfData.cc
  ../src/cgaladv_minkowski2.cc)

set(COMMON_SOURCES
  ../src/nodedumper.cc 
  ../src/traverser.cc 
  ../src/PolySetEvaluator.cc 
  ../src/PolySetCache.cc 
  ../src/Tree.cc
  lodepng.cpp)

#
# Offscreen OpenGL context source code
#
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	message(STATUS "Offscreen OpenGL Context - using Apple CGL")
	set(OFFSCREEN_CTX_SOURCE "OffscreenContext.mm" CACHE TYPE STRING)
elseif(UNIX)
	message(STATUS "Offscreen OpenGL Context - using Unix GLX")
	set(OFFSCREEN_CTX_SOURCE "OffscreenContextGLX.cc" CACHE TYPE STRING)
elseif(WIN32)
	message(STATUS "Offscreen OpenGL Context - using Microsoft WGL")
	set(OFFSCREEN_CTX_SOURCE "OffscreenContextWGL.cc" CACHE TYPE STRING)
endif()

set(OFFSCREEN_SOURCES
  OffscreenView.cc
  ${OFFSCREEN_CTX_SOURCE}
  imageutils.cc
  fbo.cc
  system-gl.cc)

add_library(tests-core STATIC ${CORE_SOURCES})
add_library(tests-common STATIC ${COMMON_SOURCES})
target_link_libraries(tests-common tests-core)
add_library(tests-cgal STATIC ${CGAL_SOURCES})
set_target_properties(tests-cgal PROPERTIES COMPILE_FLAGS "-DENABLE_CGAL ${CGAL_CXX_FLAGS_INIT}")
target_link_libraries(tests-cgal tests-common)
add_library(tests-nocgal STATIC ${NOCGAL_SOURCES})
target_link_libraries(tests-nocgal tests-common)
add_library(tests-offscreen STATIC ${OFFSCREEN_SOURCES})
# set_target_properties(tests-offscreen PROPERTIES COMPILE_FLAGS "-DENABLE_OPENCSG -DENABLE_CGAL ${CGAL_CXX_FLAGS_INIT}")

#
# echotest
#
add_executable(echotest echotest.cc)
target_link_libraries(echotest tests-nocgal tests-core ${QT_LIBRARIES} ${OPENGL_LIBRARY} ${Boost_LIBRARIES})

#
# dumptest
#
add_executable(dumptest dumptest.cc)
target_link_libraries(dumptest tests-common tests-nocgal ${QT_LIBRARIES} ${OPENGL_LIBRARY} ${Boost_LIBRARIES})

#
# csgtexttest
#
add_executable(csgtexttest csgtexttest.cc CSGTextRenderer.cc CSGTextCache.cc)
target_link_libraries(csgtexttest tests-common tests-nocgal ${QT_LIBRARIES} ${OPENGL_LIBRARY} ${Boost_LIBRARIES})

#
# csgtermtest
#
add_executable(csgtermtest csgtermtest.cc ../src/CSGTermEvaluator.cc)
target_link_libraries(csgtermtest tests-common tests-nocgal ${QT_LIBRARIES} ${OPENGL_LIBRARY} ${Boost_LIBRARIES})

#
# cgaltest
#
add_executable(cgaltest cgaltest.cc)
set_target_properties(cgaltest PROPERTIES COMPILE_FLAGS "-DENABLE_CGAL ${CGAL_CXX_FLAGS_INIT}")

=== debian/changelog ===
openscad (2011.12-3) unstable; urgency=low

  * Patch eigen2.pri to build on kfreebsd and hurd (Closes: #673694)
  * Explicitly call pkg-config to feed eigen2 paths to testing system
  * Patch tests/CMakeLists.txt to only apply FreeBSD hacks on real FreeBSD
    systems

 -- Christian M. Amsüss <chrysn@fsfe.org>  Fri, 25 May 2012 20:44:44 +0200

openscad (2011.12-2) unstable; urgency=low

  * Add a patch for tests/CMakeLists.txt so it works with -Wl,--as-needed too
  * Add a patch to include GL/glu where needed (required since Ubuntu precise)
  * Depend on cmake (ctest) for openscad-testing
  * Raise CGAL dependency to 3.6
  * Move from contrib to main as CGAL 4.0 moved from nonfree to main
  * Change Standards-Version to 3.9.3
    - Use correct Format: specifier in now official DEP5
  * Fix leftover mistake from copy/pasting in debian/copyright
  * Initial upload to Debian (Closes: #583476)
  * Enable parallel building
  * Suggest librecad instead of qcad
  * Don't recommend openscad-mcad, as it is not in the archive yet

 -- Christian M. Amsüss <chrysn@fsfe.org>  Wed, 25 Apr 2012 14:10:45 +0200

openscad (2011.12-1) UNRELEASED; urgency=low

  * New upstream release
    - New functions: version, version_num, len
    - Enhanced functionaltiy: hull(), color()
    - Unified import statement, including OFF file format
    - Enhanced string handling: indexing, comparison
    - standard shortcuts for save and reload
    - Bugfixes
  * Dropped man page (in upstream now)
  * Ship test suite as -testing and -testing-data (introduces new
    dependencies)
  * Adapted GLEW dependency to avoid something similar as bug #658551
  * License issue around OGL_helper.h resolved by CGAL moving to GPL-3+

 -- Christian M. Amsüss <chrysn@fsfe.org>  Wed, 15 Feb 2012 13:34:04 +0100

openscad (2011.11~.03-git3bc03713-1) UNRELEASED; urgency=low

  * More precise eigen dependency
  * Changed version format to better reflect how upstream calls unreleased
    builds
  * Imported changes from ustream git
    - string comparison
    - version()/version_num() functions
    - new PI constant
    - standard shortcuts for save and reload
    - bugfixes
  * Dropped openscad.pro patch (now takes PREFIX=/usr)
  * Copyright file adaptions to new files
  * Use debian/clean instead of override_dh_auto_clean
  * Run test suite after building
    - new build dependencies: python, cmake
  * Updated man page

 -- Christian M. Amsüss <chrysn@fsfe.org>  Fri, 04 Nov 2011 16:25:00 +0100

openscad (2011.09~git20110929-1) UNRELEASED; urgency=low

  * Imported changes from upstream git
    - OFF file format support
    - universal import statement (deprecating some others)
    - support for alpha channel and named colors
    - more flexible if statement
    - much refactoring ("visitor branch")
    - bugfixes
  * Copyright clarifications
  * Suggest editors / viewers for typical import and export formats
  * Recommend openscad-mcad (standard library)
  * Added README.source concerning how to obtain the source package

 -- Christian M. Amsüss <chrysn@fsfe.org>  Fri, 30 Sep 2011 03:08:01 +0200

openscad (2011.06-2) UNRELEASED; urgency=low

  * Adapt libglew dependency to 1.6 | anything
  * Updated watchfile to github hosting
  * Updated copyright to current DEP5 version

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sat, 24 Sep 2011 03:29:41 +0200

openscad (2011.06-1) UNRELEASED; urgency=low

  * New upstream release
    - Added image export
    - Fixed DXF export regression
    - Fixed cylinder orientation regression

 -- Christian M. Amsüss <chrysn@fsfe.org>  Tue, 14 Jun 2011 19:48:07 +0200

openscad (2011.04-1) UNRELEASED; urgency=low

  * New upstream release 
    - Added hull() for convex hulls (2D object only)
    - minkowski() now supports 2D objects
    - DXF output uses LWPOLYLINE instead of LINE
  * Change Standards-Version to 3.9.2 (no changes)
  * Add proper header to patch file

 -- Christian M. Amsüss <chrysn@fsfe.org>  Wed, 27 Apr 2011 19:56:29 +0200

openscad (2011.01~git20110204-2) UNRELEASED; urgency=low

  * Removing versioned dependency on libgmp dependency according to upstream
  * Removing versioned dependency on libmpfr (building works w/o as well,
    especially concerning Ubuntu lucid)

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sun, 03 Apr 2011 14:35:52 +0200

openscad (2011.01~git20110204-1) UNRELEASED; urgency=low

  * Import changes from upstream git
    - Added rands() function
    - Added support for string escapes
    - Enhancements in nested includes, number parsing, and DXF output
    - Bugfixes
  * New library dependencies
  * Copyright updates
  * Leave installing examples to the upstream installer
  * Keep openscad.desktop in debian/

 -- Christian M. Amsüss <chrysn@fsfe.org>  Mon, 21 Feb 2011 22:40:53 +0100

openscad (2010.06~svn568-1) UNRELEASED; urgency=low

  * Import bugfixes from upstream SVN
    - Enhance DXF export for Inkscape import
    - Better CGAL exception handling
    - Offer to save when creating new file
    - New sign() function
  * Change Standards-Version to 3.9.1 (no changes)
  * Removed examples patch, symlinking instead

 -- Christian M. Amsüss <chrysn@fsfe.org>  Mon, 13 Sep 2010 21:19:16 +0200

openscad (2010.06~svn560-1) UNRELEASED; urgency=low

  * Import bugfixes from upstream SVN
    - Accept 3D parameters for 2D functions
    - Fix locale dependent export problems
  * New man page for openscad

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sat, 26 Jun 2010 18:28:12 +0200

openscad (2010.05-2) UNRELEASED; urgency=low

  * New openscad.desktop
  * Create openscad.png with aspect ratio appropriate for icons
    - new build dependency on imagemagick
  * Install TODO.txt

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sat, 29 May 2010 00:54:19 +0200

openscad (2010.05-1) UNRELEASED; urgency=low

  * New upstream release:
    - more math functions
    - support for minkowski sums
    - new include syntax
    - bugfixes
  * Ship RELEASE_NOTES file
  * Don't compress example files


=== debian/control ===
Source: openscad
Priority: optional
Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
Build-Depends:
    debhelper (>= 7.0.50~),
    qt4-qmake (>=4.4),
    libcgal-dev (>=3.6),
    libopencsg-dev (>=1.3.0),
    libeigen2-dev (>= 2.0.13),
    bison (>= 2.4),
    flex (>=2.5.35),
    libqt4-opengl-dev,
    libglew-dev (>= 1.5.4) | libglew1.6-dev | libglew1.5-dev (>= 1.5.4),
    libgmp-dev | libgmp10-dev | libgmp3-dev,
    libmpfr-dev,
    imagemagick,
    python,
    cmake,
    libboost-dev (>= 1.46.0),
    chrpath,
    pkg-config
Standards-Version: 3.9.3
Section: graphics
DM-Upload-Allowed: yes
Homepage: http://openscad.org/
Vcs-Browser: http://gitorious.org/openscad-debian/openscad/commits/debian
Vcs-git: git://gitorious.org/openscad-debian/openscad.git/

Package: openscad
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
# not in archive yet
# Recommends:
#     openscad-mcad (>= 2011.12)
Suggests:
    meshlab,
    geomview,
    librecad
Description: script file based graphical CAD environment
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 OpenSCAD is not an interactive modeller. Instead it is something like a
 3D-compiler that reads in a script file that describes the object and renders
 the 3D model from this script. This gives the designer full control over the
 modelling process and enables him to easily change any step in the modelling
 process or make designes that are defined by configurable parameters.

Package: openscad-testing
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    openscad-testing-data,
    python,
    python-argparse,
    cmake
Description: script file based graphical CAD environment (test suite)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains all programs required to run the test suites.

Package: openscad-testing-data
Architecture: all
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
# the examples, which are shipped in openscad, are part of the test suite
Recommends: openscad
Suggests: openscad-testing
Description: script file based graphical CAD environment (test suite data)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains the data required to run the test suites.

Package: openscad-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    openscad (=${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Description: script file based graphical CAD environment (debugging symbols)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains debugging information stripped from the binaries.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1
%:
	dh $@ --parallel

override_dh_auto_build:
	dh_auto_build

	convert icons/icon-alpha.png -resize 688x688 -background transparent -gravity center -extent 688x688 openscad.png

	# build test suite; FIXME: why is the GLEW path not discovered automatically?
	cd tests && cmake -DGLEW_LIBRARY=`pkg-config --variable libdir glew`/libGLEW.so -DEIGEN2_INCLUDE_DIR=`pkg-config --cflags-only-I eigen2 | sed 's/^-I//'` .
	cd tests && make

	# fix absolute paths in ctest scripts
	cd tests && perl -i.bak -npe 'use Cwd; my $$here = getcwd(); s/$$here/./g' *.cmake

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# FIXME: ignoring the tests is not a nice thing to do, but it seems
	# they are too much under construction atm
	cd tests && ctest || echo "Not failing just because some tests went wrong..."
else
	@echo "Skipping test suite as requested in DEB_BUILD_OPTIONS"
endif

override_dh_auto_install:
	dh_auto_install --destdir=debian/openscad

	# don't ship mcad, neither the empty directory (when this is built from
	# a normal git source checkout) nor the full library (when this is
	# built from a git checkout with submodules or from a tarball). mcad
	# gets its own package.
	rm -rf debian/openscad/usr/share/openscad/libraries/MCAD/
	-rmdir debian/openscad/usr/share/openscad/libraries

	# solve the http://wiki.debian.org/RpathIssue the brutal way; it's only
	# the testing scripts and not the regular build process for openscad,
	# so i'll accept not getting the extra score for finding out what's
	# wrong exactly
	for x in \
		cgalpngtest \
		cgalstlsanitytest \
		cgaltest \
		csgtermtest \
		csgtexttest \
		dumptest \
		echotest \
		opencsgtest \
		throwntogethertest\
		; do chrpath -d tests/$$x; done

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# can't do that in debian/openscad-testing-data.install as it would fail when building with nocheck
	mkdir -p debian/openscad-testing-data/usr/share/openscad/buildtestresults/
	for x in tests/*-output; do dh_install --package openscad-testing-data $$x /usr/share/openscad/buildtestresults/; done
endif

override_dh_strip:
	dh_strip --dbg-package openscad-dbg

=== debian/watch ===
version=3

https://github.com/openscad/openscad/downloads /downloads/openscad/openscad/openscad-([0-9.]+).src.tar.gz

## openscad 2013.01+dfsg

=== tests/CMakeLists.txt ===
# instructions - see ../doc/testing.txt

cmake_minimum_required(VERSION 2.8)
if("${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION}" VERSION_GREATER 2.8.3)
  # Explicitly use new include policy to avoid globally shadowing included modules
  # http://www.cmake.org/cmake/help/cmake-2-8-docs.html#policy:CMP0017
  cmake_policy(SET CMP0017 NEW)
endif()

# Detect Lion and force gcc
IF (APPLE)
   EXECUTE_PROCESS(COMMAND sw_vers -productVersion OUTPUT_VARIABLE MACOSX_VERSION)
   IF (NOT ${MACOSX_VERSION} VERSION_LESS "10.7.0")
     message("Detected Lion or later")
     set(CMAKE_C_COMPILER "gcc")
     set(CMAKE_CXX_COMPILER "g++")
   ELSE()
     message("Detected Snow Leopard or older")
     if (USE_LLVM)
       message("Using LLVM compiler")
       set(CMAKE_C_COMPILER "llvm-gcc")
       set(CMAKE_CXX_COMPILER "llvm-g++")
     endif()
   ENDIF()
ENDIF(APPLE)


project(tests)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")

# Build debug build as default
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing")
endif()

if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDEBUG")
endif()

#
# Windows
#

if(WIN32 AND MSVC)
  set(WIN32_STATIC_BUILD "True")
endif()

if(WIN32_STATIC_BUILD AND MSVC)
  if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    set(EMSG "\nTo build Win32 STATIC OpenSCAD please see doc/testing.txt")
    message(FATAL_ERROR ${EMSG})
  endif()
endif()

# Disable warnings
if(WIN32 AND MSVC)
  # too long decorated names
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4503")
  # int cast to bool in CGAL
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4800")
  # unreferenced parameters in CGAL
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4100")
  # fopen_s advertisement
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_CRT_SECURE_NO_DEPRECATE")
  # lexer uses strdup & other POSIX stuff
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_CRT_NONSTDC_NO_DEPRECATE")
  # M_PI
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_USE_MATH_DEFINES")
endif()

# Debugging - if you uncomment, use nmake -f Makefile > log.txt (the log is big)
if(WIN32 AND MSVC)
  # Linker debugging
  #set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -VERBOSE")

  # Compiler debugging
  # you have to pass -DCMAKE_VERBOSE_MAKEFILE=ON to cmake when you run it. 
endif()

if(WIN32 AND CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -frounding-math")
endif()

# Clang compiler

if(CMAKE_CXX_COMPILER MATCHES ".*clang.*")
  # disable enormous amount of warnings about CGAL
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-function")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-c++11-extensions")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-sign-compare")
endif()

#
# Build test apps
#

function(inclusion user_set_path found_paths)
  # If user_set_path indicates an env. variable was specifically
  # set by the user, then found_paths become an include priority (prepend);
  # otherwise found_paths are stuck on the end of the include flags (append).

  # message(STATUS "inclusion ${user_set_path} ${found_paths}")
  # message(STATUS "inclusion ${${user_set_path}} ${${found_paths}}")
  set( inclusion_match 0 )
  foreach( found_path ${${found_paths}} )
    if (${found_path} MATCHES ${${user_set_path}}.*)
      set( inclusion_match 1 )
    endif()
  endforeach()
  if (user_set_path AND inclusion_match)
    include_directories(BEFORE ${${found_paths}})
    # message(STATUS "inclusion prepend ${${found_paths}} for ${user_set_path}")
  else()
    include_directories(AFTER ${${found_paths}})
    # message(STATUS "inclusion append ${${found_paths}} for ${user_set_path}")
  endif()
  set( inclusion_match 0 )
endfunction()

# Boost
# 
# FindBoost.cmake has been included from Cmake's GIT circa the end of 2011
# because most existing installs of cmake had a buggy older version. 
#
# Update this if FindBoost.cmake gets out of sync with the current boost release
# set(Boost_ADDITIONAL_VERSIONS "1.47.0" "1.46.0")

if (WIN32)
  set(Boost_USE_STATIC_LIBS TRUE)
  set(BOOST_STATIC TRUE)
  set(BOOST_THREAD_USE_LIB TRUE)
endif()

if (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(BOOST_ROOT "$ENV{OPENSCAD_LIBRARIES}")
  if (EXISTS ${BOOST_ROOT}/include/boost)
    # if boost is under OPENSCAD_LIBRARIES, then 
    # don't look in the system paths (workaround FindBoost.cmake bug)
    set(Boost_NO_SYSTEM_PATHS "TRUE")
    message(STATUS "BOOST_ROOT: " ${BOOST_ROOT})
  endif()
endif()

if (NOT $ENV{BOOSTDIR} STREQUAL "")
  set(BOOST_ROOT "$ENV{BOOSTDIR}")
  set(Boost_NO_SYSTEM_PATHS "TRUE")
  set(Boost_DEBUG TRUE)
  message(STATUS "BOOST_ROOT: " ${BOOST_ROOT})
endif()

find_package( Boost 1.35.0 COMPONENTS thread program_options filesystem system regex REQUIRED)
message(STATUS "Boost includes found: " ${Boost_INCLUDE_DIRS})
message(STATUS "Boost libraries found:")
foreach(boostlib ${Boost_LIBRARIES})
  message(STATUS "  " ${boostlib})
endforeach()

inclusion(BOOST_ROOT Boost_INCLUDE_DIRS)
add_definitions(-DBOOST_FILESYSTEM_VERSION=3) # Use V3 for boost 1.44-1.45

# Mac OS X
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  FIND_LIBRARY(COCOA_LIBRARY Cocoa REQUIRED)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

# Qt4

set(CMAKE_INCLUDE_DIRECTORIES_BEFORE ON)
find_package(OpenGL REQUIRED)

if (MINGW_CROSS_ENV_DIR) 
  mingw_cross_env_find_qt()
  mingw_cross_env_info()
  include_directories( ${QT_INCLUDE_DIRS} )
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${QT_CFLAGS_OTHER}")
else()
  find_package(Qt4 COMPONENTS QtCore REQUIRED)
  include(${QT_USE_FILE})
endif()

set(CMAKE_INCLUDE_DIRECTORIES_BEFORE OFF)


# Eigen

# Turn off Eigen SIMD optimization
if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DEIGEN_DONT_ALIGN")
  endif()
endif()

# Priority
# 3. EIGENDIR if set (EIGEN2DIR for backwards compatability)
# 1. OPENSCAD_LIBRARIES eigen3
# 2. OPENSCAD_LIBRARIES eigen2
# 4. system's standard include paths for eigen3
# 5. system's standard include paths for eigen2

set(EIGEN2_DIR "$ENV{EIGEN2DIR}")
set(EIGEN_DIR "$ENV{EIGENDIR}")
set(OPENSCAD_LIBDIR "$ENV{OPENSCAD_LIBRARIES}")

if (EIGEN_DIR)
  set(EIGHINT ${EIGEN_DIR}/include/eigen3 ${EIGEN_DIR}/include/eigen2 ${EIGEN_DIR})
  find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS ${EIGHINT})
endif()
if (EIGEN2_DIR)
  find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS ${EIGEN2_DIR}/include/eigen2 ${EIGEN2_DIR})
endif()

if (NOT EIGEN_INCLUDE_DIR)
  find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS ${OPENSCAD_LIBDIR}/include/eigen3)
endif()
if (NOT EIGEN_INCLUDE_DIR)
  find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS ${OPENSCAD_LIBDIR}/include/eigen2)
endif()

if (NOT EIGEN_INCLUDE_DIR)
  if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/local/include/eigen3)
  elseif (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/pkg/include/eigen3)
  elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /opt/local/include/eigen3)
  else()
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/include/eigen3)
  endif()
endif()

if (NOT EIGEN_INCLUDE_DIR)
  if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/local/include/eigen2)
  elseif (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/pkg/include/eigen2)
  elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /opt/local/include/eigen2)
  else()
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/include/eigen2)
  endif()
endif()

if (NOT EIGEN_INCLUDE_DIR)
  message(STATUS "Eigen not found")
else()
  message(STATUS "Eigen found in " ${EIGEN_INCLUDE_DIR})
  inclusion(EIGEN_DIR EIGEN_INCLUDE_DIR)
endif()


# OpenCSG
if (NOT $ENV{OPENCSGDIR} STREQUAL "")
  set(OPENCSG_DIR "$ENV{OPENCSGDIR}")
elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(OPENCSG_DIR "$ENV{OPENSCAD_LIBRARIES}")
endif()
if (NOT OPENCSG_INCLUDE_DIR)
  message(STATUS "OPENCSG_DIR: " ${OPENCSG_DIR})
  find_path(OPENCSG_INCLUDE_DIR
            opencsg.h
            HINTS ${OPENCSG_DIR}/include)
  find_library(OPENCSG_LIBRARY
               opencsg
               HINTS ${OPENCSG_DIR}/lib)
  if (NOT OPENCSG_INCLUDE_DIR OR NOT OPENCSG_LIBRARY)
    message(FATAL_ERROR "OpenCSG not found")
  else()
    message(STATUS "OpenCSG include found in " ${OPENCSG_INCLUDE_DIR})
    message(STATUS "OpenCSG library found in " ${OPENCSG_LIBRARY})
  endif()
endif()
inclusion(OPENCSG_DIR OPENCSG_INCLUDE_DIR)

# GLEW

if(WIN32_STATIC_BUILD)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DGLEW_STATIC")
endif()

if (NOT $ENV{GLEWDIR} STREQUAL "")
  set(GLEW_DIR "$ENV{GLEWDIR}")
elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(GLEW_DIR "$ENV{OPENSCAD_LIBRARIES}")
endif()
if (NOT GLEW_INCLUDE_DIR)
  message(STATUS "OPENCSG_DIR: " ${OPENCSG_DIR})
  find_path(GLEW_INCLUDE_DIR
            GL/glew.h
            HINTS ${GLEW_DIR}/include
	    NO_DEFAULT_PATH)
  find_library(GLEW_LIBRARY
               NAMES GLEW glew
               HINTS ${GLEW_DIR}/lib ${GLEW_DIR}/lib64
	       NO_DEFAULT_PATH)
  if (NOT GLEW_LIBRARY)
    find_package(GLEW REQUIRED)
    if (NOT GLEW_LIBRARY)
      message(FATAL_ERROR "GLEW not found")
    endif()
  endif()
  message(STATUS "GLEW include: " ${GLEW_INCLUDE_DIR})
  message(STATUS "GLEW library: " ${GLEW_LIBRARY})
endif()

inclusion(GLEW_DIR GLEW_INCLUDE_DIR)

# Flex/Bison
find_package(BISON REQUIRED)

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  # FreeBSD has an old flex in /usr/bin and a new flex in /usr/local/bin
  set(FLEX_EXECUTABLE /usr/local/bin/flex)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
  include_directories( /usr/pkg/include /usr/X11R7/include )
  set(FLEX_EXECUTABLE /usr/pkg/bin/flex)
endif()

find_package(FLEX REQUIRED)
# The COMPILE_FLAGS and forced C++ compiler is just to be compatible with qmake
if (WIN32)
  set(FLEX_UNISTD_FLAG "-DYY_NO_UNISTD_H")
endif()
FLEX_TARGET(OpenSCADlexer ../src/lexer.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.cpp COMPILE_FLAGS "-Plexer ${FLEX_UNISTD_FLAG}")
BISON_TARGET(OpenSCADparser ../src/parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser_yacc.c COMPILE_FLAGS "-p parser")
ADD_FLEX_BISON_DEPENDENCY(OpenSCADlexer OpenSCADparser)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/parser_yacc.c PROPERTIES LANGUAGE "CXX")

# CGAL

if (NOT $ENV{CGALDIR} STREQUAL "")
  set(CGAL_DIR "$ENV{CGALDIR}")
elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  if (EXISTS "$ENV{OPENSCAD_LIBRARIES}/lib/CGAL")
    set(CGAL_DIR "$ENV{OPENSCAD_LIBRARIES}/lib/CGAL")
    set(CMAKE_MODULE_PATH "${CGAL_DIR}")
  elseif (EXISTS "$ENV{OPENSCAD_LIBRARIES}/include/CGAL")
    set(CGAL_DIR "$ENV{OPENSCAD_LIBRARIES}")
    set(CMAKE_MODULE_PATH "${CGAL_DIR}")
  endif()
endif()
message(STATUS "CGAL_DIR: " ${CGAL_DIR})
find_package(CGAL REQUIRED)
message(STATUS "CGAL config found in " ${CGAL_USE_FILE} )
foreach(cgal_incdir ${CGAL_INCLUDE_DIRS})
  message(STATUS "CGAL include found in " ${cgal_incdir} )
endforeach()
message(STATUS "CGAL libraries found in " ${CGAL_LIBRARIES_DIR} )
if("${CGAL_MAJOR_VERSION}.${CGAL_MINOR_VERSION}" VERSION_LESS 3.6)
  message(FATAL_ERROR "CGAL >= 3.6 required")
endif()
inclusion(CGAL_DIR CGAL_INCLUDE_DIRS)

# Imagemagick

if (NOT SKIP_IMAGEMAGICK)
  find_package(ImageMagick COMPONENTS convert)
  if (ImageMagick_convert_FOUND)
    message(STATUS "ImageMagick convert executable found: " ${ImageMagick_convert_EXECUTABLE})
  else()
    message(FATAL_ERROR "Couldn't find imagemagick 'convert' program")
  endif()
endif()

# Internal includes
include_directories(../src)

=== debian/changelog ===
openscad (2013.01+dfsg-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix for bad boost libraries. (Closes: #736544)

 -- Anton Gladky <gladk@debian.org>  Fri, 24 Jan 2014 20:12:03 +0100

openscad (2013.01+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Replace libeigen2-dev by libeigen3-dev. (Closes: #726157)

 -- Anton Gladky <gladk@debian.org>  Sat, 18 Jan 2014 22:01:18 +0100

openscad (2013.01+dfsg-2) unstable; urgency=low

  * Fix eigen.pri to build on kfreebsd. (Patch by Don Bright)
  * Upload to unstable.

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sat, 23 Feb 2013 11:19:35 +0100

openscad (2013.01+dfsg-1) experimental; urgency=low

  * Added reportbug helper (includes glxinfo data in bug reports)
  * New upstream version (still to experimental, lest #673694 resurface)
    - Use the OPENSCADPATH environment variable
  * Copyright file adaptions to new files
  * Change Standards-Version to 3.9.4
    - "-b" option added to Vcs-Git
  * Removed DM-Upload-Allowed flag due to changed procedures
  * Changed watch file to googlecode

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sun, 04 Nov 2012 18:47:45 +0100

openscad (2012.05~.12-git67eb2ebe-1) experimental; urgency=low

  * Build-depend on boost modules required by new version
  * Specify GLEW include dir for tests
  * Un-apply 1b98da3f (GL/glu.h includes), fixed upstream
  * Un-apply 1cd856be (CMakeList fix), fixed upstream
  * Include upstream git snapshot
    - More configuration options for cache and performance
    - Dot product
    - Matrix multiplication
    - New search function
    - Bugfixes
  * Drop custom .desktop file and icon generation, handled upstream
  * Copyright file adaptions to new files

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sat, 12 May 2012 16:52:26 +0200

openscad (2011.12-4) UNRELEASED; urgency=low

  * Acknowledge DM-Upload-Allowed: yes
  * Enable hardening flags
  * Switch to debhelper 9 to ease configuration

 -- Christian M. Amsüss <chrysn@fsfe.org>  Mon, 28 May 2012 00:13:01 +0200

=== debian/control ===
--- 
+++ 
@@ -2,29 +2,31 @@
 Priority: optional
 Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
 Build-Depends:
-    debhelper (>= 7.0.50~),
+    debhelper (>= 9),
     qt4-qmake (>=4.4),
     libcgal-dev (>=3.6),
     libopencsg-dev (>=1.3.0),
-    libeigen2-dev (>= 2.0.13),
+    libeigen3-dev,
     bison (>= 2.4),
     flex (>=2.5.35),
     libqt4-opengl-dev,
     libglew-dev (>= 1.5.4) | libglew1.6-dev | libglew1.5-dev (>= 1.5.4),
     libgmp-dev | libgmp10-dev | libgmp3-dev,
     libmpfr-dev,
-    imagemagick,
     python,
     cmake,
     libboost-dev (>= 1.46.0),
+    libboost-regex-dev,
+    libboost-system-dev,
+    libboost-filesystem-dev,
     chrpath,
-    pkg-config
-Standards-Version: 3.9.3
+    pkg-config,
+    imagemagick
+Standards-Version: 3.9.4
 Section: graphics
-DM-Upload-Allowed: yes
 Homepage: http://openscad.org/
 Vcs-Browser: http://gitorious.org/openscad-debian/openscad/commits/debian
-Vcs-git: git://gitorious.org/openscad-debian/openscad.git/
+Vcs-Git: git://gitorious.org/openscad-debian/openscad.git/ -b debian
 
 Package: openscad
 Architecture: any
@@ -56,7 +58,8 @@
     openscad-testing-data,
     python,
     python-argparse,
-    cmake
+    cmake,
+    imagemagick
 Description: script file based graphical CAD environment (test suite)
  OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
  aspects rather than artistic ones.

=== debian/rules ===
--- 
+++ 
@@ -1,16 +1,21 @@
 #!/usr/bin/make -f
 
 # export DH_VERBOSE=1
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
 %:
 	dh $@ --parallel
 
 override_dh_auto_build:
 	dh_auto_build
 
-	convert icons/icon-alpha.png -resize 688x688 -background transparent -gravity center -extent 688x688 openscad.png
-
 	# build test suite; FIXME: why is the GLEW path not discovered automatically?
-	cd tests && cmake -DGLEW_LIBRARY=`pkg-config --variable libdir glew`/libGLEW.so -DEIGEN2_INCLUDE_DIR=`pkg-config --cflags-only-I eigen2 | sed 's/^-I//'` .
+	cd tests && CFLAGS="$$CFLAGS $$CPPFLAGS" CXXFLAGS="$$CXXFLAGS $$CPPFLAGS" cmake \
+		-DGLEW_LIBRARY=`pkg-config --variable libdir glew`/libGLEW.so \
+		-DGLEW_INCLUDE_DIR=`pkg-config --variable includedir` \
+		-DEIGEN_INCLUDE_DIR=`pkg-config --cflags-only-I eigen3 | sed 's/^-I//'` \
+		.
 	cd tests && make
 
 	# fix absolute paths in ctest scripts

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg$// \
    http://code.google.com/p/openscad/downloads/list?can=1 .*/openscad-([0-9.]*).src.tar.gz \
    debian sh debian/repack.stub

## openscad 2014.03%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -3,9 +3,13 @@
 # export DH_VERBOSE=1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+UPSTREAMVERS = $(shell dpkg-parsechangelog | sed -n 's/^Version: \([^+~]*\).*$$/\1/p')
 
 %:
 	dh $@ --parallel
+
+override_dh_auto_configure:
+	dh_auto_configure -- VERSION=$(UPSTREAMVERS)
 
 override_dh_auto_build:
 	dh_auto_build
@@ -18,17 +22,34 @@
 		.
 	cd tests && make
 
-	# fix absolute paths in ctest scripts
-	cd tests && perl -i.bak -npe 'use Cwd; my $$here = getcwd(); s/$$here/./g' *.cmake
+	# fix absolute paths in ctest scripts (relative paths will work during
+	# the build time tests, and are catered for by the openscad-testrun
+	# script).
+	cd tests && perl -i.bak -npe 'use Cwd; my $$here = getcwd(); s/\Q$$here\E/./g' *.cmake
+	# fix relative paths to plain binary names (the $PATH will be
+	# explicitly set during build time tests, and with openscad-testrun, it
+	# will have been installed).
+	cd tests && sed 's@\./\.\./openscad@openscad@' -i *.cmake
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# FIXME: ignoring the tests is not a nice thing to do, but it seems
 	# they are too much under construction atm
-	cd tests && ctest || echo "Not failing just because some tests went wrong..."
+	#
+	# PATH has to be set as the explicit ../openscad reference was removed above.
+	# OPENSCADPATH has to be set because the default library dir is
+	# determined based on the openscad binary's path (will be ok after
+	# installation).
+	cd tests && PATH=..:$$PATH OPENSCADPATH=/usr/share/openscad/libraries ctest || echo "Not failing just because some tests went wrong..."
 else
 	@echo "Skipping test suite as requested in DEB_BUILD_OPTIONS"
 endif
+
+	# fix absolute paths in generated scad files. this step logically
+	# belongs to the similar lines in the dh_auto_build override, but can
+	# first be done here becaus for the build time tests, the original
+	# paths are still required.
+	find testdata -name \*.scad  -exec perl -i.bak -npe 'use Cwd; my $$here = getcwd(); s[\Q$$here\E/tests/../testdata][/usr/share/openscad/testdata]g' {} +
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/openscad
@@ -45,15 +66,7 @@
 	# so i'll accept not getting the extra score for finding out what's
 	# wrong exactly
 	for x in \
-		cgalpngtest \
-		cgalstlsanitytest \
-		cgaltest \
-		csgtermtest \
 		csgtexttest \
-		dumptest \
-		echotest \
-		opencsgtest \
-		throwntogethertest\
 		; do chrpath -d tests/$$x; done
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
